Node Groups API
List Kubernetes node groups and get group details including instance types, node counts, spot allocation, and per-group cost via the Kubeadapt API.
Node group endpoints return data for autoscaling groups and node pools in your clusters. Use these to understand capacity and cost at the infrastructure tier.
Required scope: node_groups:read
List Node Groups
text
GET /v1/node-groupsReturns a paginated list of node groups across your organization.
Query Parameters
| Parameter | Type | Default | Description |
|---|---|---|---|
cluster_id | string | Filter by cluster ID | |
limit | integer | 100 | Number of results to return (1 to 500) |
offset | integer | 0 | Number of results to skip |
Example Request
bash
curl -H "Authorization: Bearer ka_your_api_key" \
"https://public-api.kubeadapt.io/v1/node-groups?cluster_id=cls-abc123"Example Response
json
{
"node_groups": [
{
"id": "ng-abc001",
"name": "general-purpose",
"cluster_id": "cls-abc123",
"cluster_name": "prod-us-east",
"node_count": 6,
"instance_type": "m5.xlarge",
"total_cpu_cores": 24.0,
"total_memory_gb": 96.0,
"spot_percentage": 0.0,
"hourly_cost": 1.152
},
{
"id": "ng-abc002",
"name": "compute-optimized",
"cluster_id": "cls-abc123",
"cluster_name": "prod-us-east",
"node_count": 4,
"instance_type": "c5.2xlarge",
"total_cpu_cores": 32.0,
"total_memory_gb": 64.0,
"spot_percentage": 0.0,
"hourly_cost": 1.36
}
],
"total": 2
}Node Group Details
text
GET /v1/node-groups/{group_name}/detailsReturns detailed information for a specific node group, including the individual nodes in the group.
Path Parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
group_name | string | Yes | Node group name |
Query Parameters
| Parameter | Type | Default | Description |
|---|---|---|---|
cluster_id | string | Required. The cluster the node group belongs to |
Example Request
bash
curl -H "Authorization: Bearer ka_your_api_key" \
"https://public-api.kubeadapt.io/v1/node-groups/general-purpose/details?cluster_id=cls-abc123"Example Response
json
{
"name": "general-purpose",
"cluster_id": "cls-abc123",
"cluster_name": "prod-us-east",
"instance_type": "m5.xlarge",
"node_count": 6,
"total_cpu_cores": 24.0,
"total_memory_gb": 96.0,
"spot_percentage": 0.0,
"hourly_cost": 1.152,
"avg_cpu_utilization": 45.0,
"avg_memory_utilization": 60.6,
"nodes": [
{
"id": "nd-node01",
"node_name": "ip-10-0-1-100.ec2.internal",
"instance_type": "m5.xlarge",
"availability_zone": "us-east-1a",
"is_ready": true,
"cpu_capacity": 4.0,
"cpu_allocatable": 3.92,
"memory_capacity_gb": 16.0,
"memory_allocatable_gb": 15.2,
"pods_capacity": 58,
"hourly_cost": 0.192,
"spot_instance": false
},
{
"id": "nd-node02",
"node_name": "ip-10-0-1-101.ec2.internal",
"instance_type": "m5.xlarge",
"availability_zone": "us-east-1b",
"is_ready": true,
"cpu_capacity": 4.0,
"cpu_allocatable": 3.92,
"memory_capacity_gb": 16.0,
"memory_allocatable_gb": 15.2,
"pods_capacity": 58,
"hourly_cost": 0.192,
"spot_instance": false
}
]
}